<?php
/**
*   BillinkAPI
*
*   Do not copy, modify or distribute this document in any form.
*
*   @author     Matthijs <matthijs@blauwfruit.nl>
*   @copyright  Copyright (c) 2013-2019 blauwfruit (http://blauwfruit.nl)
*   @license    Proprietary Software
*   @category   category
*
*/

/**
 * 
 */
class BillinkAPI
{
    /**
     *  API responses of 
     */
    const STATES_CHECK = array(
        '001' => 'Onbekende API versie.',
        '101' => 'Onbekende gebruikersnaam of UID.',
        '102' => 'Onbekende gebruikersnaam of UID.',
        '103' => 'Onbekende actie.',
        '104' => 'Workflownummer ontbreekt.',
        '105' => 'Verkeerd workflownummer.',
        '402' => 'Verkeerd telefoonnummer formaat.',
        '406' => 'Type ontbreekt.',
        '407' => 'Verkeerd type.',
        '408' => 'Bedrijfsnaam ontbreekt.',
        '410' => 'Achternaam ontbreekt.',
        '411' => 'KvK ontbreekt.',
        '412' => 'Voornaam of initialen ontbreken.',
        '414' => 'Huisnummer ontbreekt.',
        '415' => 'Postcode ontbreekt.',
        '416' => 'Verkeerd postcode formaat.',
        '417' => 'Telefoonnummer ontbreekt.',
        '418' => 'Verkeerd geboortedatum formaat. Gebruik dd-mm-yyyy.',
        '419' => 'Email ontbreekt.',
        '420' => 'Verkeerd email formaat.',
        '421' => 'Geboortedatum ontbreekt.',
        '422' => 'Minimale leeftijd om met Billink te kunnen bestellen is 16 jaar.',
        '424' => 'Verkeerd huisnummer formaat.',
        '426' => 'Verkeerd afleveradres',
        '427' => 'Orderbedrag ontbreekt.',
        '428' => 'Verkeerd orderbedrag.',
        '429' => 'Bedrag is hoger dan toegestaan.', // Originally the, for clients, rather confusing message: Bedrag is hoger dan afgesproken.
        '430' => 'Bedrijfsnaam moet tussen de 2 en 50 karakters lang zijn.',
        '431' => 'Huisnummer extentie moet tussen de 0 en 10 karakters lang zijn.',
        '432' => 'Wrong check type provided',
        '433' => 'Incorrect country code',
        '434' => 'Incorrect delivery country code',
        '601' => 'Fout bij het parseren van het XML-bestand.',
        '603' => 'Redirect API fout. Neem contact op met Billink.',
        '607' => 'Gebruiker niet gevonden.',
        '701' => 'Klant is afgewezen voor de credit check.',
        '703' => 'Financiële regeling ontbreekt.',
    );

    const STATES_ORDER = array(
        '001' =>  'Onbekende API versie.',
        '101' =>  'Onbekende gebruikersnaam of UID.',
        '102' =>  'Onbekende gebruikersnaam of UID.',
        '103' =>  'Onbekende actie.',
        '401' =>  'Verkeerd workflownummer.',
        '402' =>  'Het opgegeven workflownummer bestaat niet.',
        '403' =>  'Factuurnummer ontbreekt.',
        '404' =>  'Het opgegeven factuurnummer bestaat al.',
        '405' =>  'Missing date.',
        '406' =>  'Type ontbreekt.',
        '407' =>  'Verkeerd type.',
        '408' =>  'Bedrijfsnaam ontbreekt.',
        '409' =>  'Voornaam of initialen ontbreken.',
        '410' =>  'Achternaam ontbreekt.',
        '411' =>  'Geslacht ontbreekt.',
        '412' =>  'Verkeerd geslacht formaat.',
        '413' =>  'Straat ontbreekt.',
        '414' =>  'Huisnummer ontbreekt.',
        '415' =>  'Postcode ontbreekt.',
        '416' =>  'Plaatsnaam ontbreekt.',
        '417' =>  'Telefoonnummer ontbreekt.',
        '418' =>  'Email ontbreekt.',
        '419' =>  'Plaatsnaam mag alleen letters, spaties, - en \' tekens bevatten.',
        '420' =>  'Onjuiste landcode, gebruik ISO 3166-1 alpha-2.',
        '421' =>  'Geboortedatum ontbreekt.',
        '422' =>  'Verkeerd IP-adres formaat.',
        '425' =>  'Rekeningnummer ontbreekt.',
        '426' =>  'Rekeninghouder ontbreekt.',
        '427' =>  'KvK nummer ontbreekt.',
        '428' =>  'Artikelcode is te lang.',
        '429' =>  'KvK nummer moet tussen de 5 en 25 karakters bevatten.',
        '430' =>  'Verkeerde btw-waarde, gebruik de volgende waardes (\'20\', \'1.20\', \'21\', \'1.21\', \'19\', \'1.19\', \'7\', \'1.07\', \'6\', \'1.06\', \'0\' or \'1.0\').',
        '431' =>  'Verkeerd btw-nummer formaat.',
        '432' =>  'Verkeerd email formaat.',
        '433' =>  'Secondaire mail is verkeerd ingevuld.',
        '434' =>  'Factuurnummer voldoet niet aan de vereisten. Alleen alfanumeriek is toegestaan. _ (onderstreping) en - (koppelteken).',
        '440' =>  'UIDD vanuit de check is niet gevonden.',
        '441' =>  'Verkeerd mandaat id. Mag alleen getallen bevatten.',
        '442' =>  'Verkeerd mandaat type. Gebruik: "FIRST, "RECURRING" of "ONETIME".',
        '443' =>  'Geef een geldig iban / rekeningnummer op.',
        '444' =>  'Orderbedrag is hoger dan aangevraagd in de check.',
        '445' =>  'De UIDD van de check is verlopen.',
        '446' =>  'De check UIDD is al bij een andere factuur gebruikt.',
        '447' =>  'Check UIDD ontbreekt.',
        '448' =>  'Bedrijfsnaam moet tussen de 2 en 50 karakters lang zijn.',
        '449' =>  'Telefoonnummer mag alleen nummers bevatten.',
        '450' =>  'Huisnummer extentie moet tussen de 0 en 10 karakters lang zijn.',
        '451' =>  'Workflow without guarantee is used for check request.',
        '601' =>  'Fout bij het parseren van het XML-bestand.',
        '603' =>  'Redirect API fout. Neem contact op met Billink.',
        '701' =>  'Klant is afgewezen voor de credit check.',
    );

    private $credentials = array();

    public function __construct()
    {
        $this->mode = (int)Configuration::get('BILLINK_MODE');
        
        $this->usr = Configuration::get('BILLINK_USR');
        $this->user_id = Configuration::get('BILLINK_USER_ID');
        $this->workflow = Configuration::get('BILLINK_WORKFLOW');
        $this->version = Configuration::get('BILLINK_VERSION');
        
        $this->costs = Configuration::get('BILLINK_COSTS');
        $this->tax = Configuration::get('BILLINK_TAX');
        $this->advise = Configuration::get('BILLINK_ADVISE');
        $this->max = Configuration::get('BILLINK_MAX');

        $this->credentials = array(
            'CLIENTUSERNAME' => $this->usr,
            'CLIENTID' => $this->user_id,
            'WORKFLOWNUMBER' => $this->workflow,
            'VERSION' => $this->version,
        );

    }

    /**
     *  API request to Billink Payment web service
     *
     *  @param  string  api request uri name space e.g. /order, /check
     *  @param  string  xml data produced in getXML
     *  @return array   result and message, or error messages
     */
    public function request($uri, $data)
    {
        $data = array_merge($data, $this->credentials);
        /**
         *  Weird shit ahead: somehow someone decided that "0 = production" in the configuration page
         */
        $url = !(int)$this->mode ? 'https://test.billink.nl/api' . $uri : 'https://client.billink.nl/api' . $uri;
        $xml = $this->getXML($data);

        $options = array(
            CURLOPT_URL => $url,
            CURLOPT_HEADER => true,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => $xml,
            CURLOPT_HTTPHEADER => array(
            "Content-Type: text/xml",
            "Content-Length: " . strlen($xml)
        ));
        $cUrl = curl_init();
        curl_setopt_array($cUrl, $options);
        $response = curl_exec($cUrl);
        $info = curl_getinfo($cUrl);
        $responseHeaders = substr($response,  0, $info['header_size']);
        $responseBody = substr($response, $info['header_size']);

        if (!$responseHeaders || $info['http_code'] !== 200) {
            Logger::addLog('[billinkpayment] webservice not available');
            return false;
        }
        
        $response = new SimpleXMLElement($responseBody);

        if ($response->RESULT == 'ERROR') {
            return array(
                'success' => false,
                'code' => (int)$response->ERROR->CODE,
                'message' => (string)$response->ERROR->DESCRIPTION[0],
                'real_response' => $response
            );
        }
        if ($response->RESULT == 'MSG') {
            return array(
                'success' => (int)$response->MSG->CODE == 500,
                'code' => (int)$response->MSG->CODE,
                'message' => (string)$response->MSG->DESCRIPTION[0],
                'real_response' => $response
            );
        }
    }

    /**
     *  Creates an XML string from an array
     *  
     *  @param  array   an array of data to prepare for an api request
     *  @return string  xml ready to make an api call
     */
    public static function getXML($array)
    {
        $xml = new SimpleXMLElement('<API/>');
        BillinkAPI::arrayToXML($array, $xml);
        return $xml->asXML();
    }

    /**
     *  Converts array to xml
     *  https://stackoverflow.com/a/5965940/1240123
     *  Revision: https://stackoverflow.com/revisions/5965940/2
     *
     *  @param  array   data to be coverted
     *  @param  object  xml object to continue on
     *  @return null    xml object will be updated
     */
    public static function arrayToXML($data, &$xml) {
        foreach ($data as $key => $value) {
            if (is_array($value)) {
                if (!is_numeric($key)) {
                    $subnode = $xml->addChild("$key");
                    BillinkAPI::arrayToXML($value, $subnode);
                } else{
                    BillinkAPI::arrayToXML($value, $xml);
                }
            } else {
                $xml->addChild("$key", htmlspecialchars($value));
            }
        }
    }
}
