{*
*   Billink Payment
*
*   Do not copy, modify or distribute this document in any form.
*
*   @copyright  Copyright (c) 2013-2019 blauwfruit (http://www.blauwfruit.nl)
*   @license    Proprietary Software
*   @author     Matthijs <matthijs@blueraspberry.nl>
*   @category   payment
*
*}

{capture name=path}
    {l s='Betalen met Billink' mod='billinkpayment'}
{/capture}

<div class="container">
    <div class="row">
        <div class="span2"></div>
        <div class="span6">
            <h2>{l s='Samenvatting van uw bestelling' mod='billinkpayment'}</h2>
            {assign var='current_step' value='payment'}
            {if $nbProducts <= 0}
                <p class="alert alert-warning">{l s='Uw winkelwagen is leeg.' mod='billinkpayment'}</p>
            {else}

                <form action="" method="post">
                    <hr>
                    <h3>{l s='Koop nu en betaal later' mod='billinkpayment'}</h3>
                    <p>{l s='U heeft ervoor gekozen om uw bestelling achteraf te betalen (op factuur).' mod='billinkpayment'}</p>
                    <p>{l s='Hier ziet u een kort overzicht van uw order:' mod='billinkpayment'}</p>
                    <ul>
                        <li>
                            {l s='Het totaalbedrag van uw order' mod='billinkpayment'} <span id="amount" class="price">{$total}</span>{if $use_taxes == 1} {l s='(tax incl.)' mod='billinkpayment'}{/if}
                        </li>
                        <li>
                            {l s='Uw winkelwagen bevat %d producten' sprintf=[$nbProducts] mod='billinkpayment'}
                        </li>
                    </ul>
                    <br>


                    <h1>{l s='Koop nu en betaal binnen 14 dagen op factuur' mod='billinkpayment'}</h1>
                    
                    {if $address->company}
                        <p>
                            {if $country->iso_code == 'NL'}
                                <label>{l s='KvK-nummer' mod='billinkpayment'}</label>
                            {elseif $country->iso_code == 'BE'}
                                <label>{l s='Ondernemingsnummer' mod='billinkpayment'}</label>
                            {else}
                                <label>{l s='Chamber of Commerce number' mod='billinkpayment'}</label>
                            {/if}
                            <input type="number" name="cocnumber" value="{$address->dni}">
                        </p>
                    {else}
                        <p>
                            <label>{l s='Geboortedatum' mod='billinkpayment'}</label>
                            <input type="text" name="birthday" class="formatted-date" value="{$birthday.value}" max="{$birthday.max}" min="{$birthday.min}">
                        </p>
                    {/if}

                    <script>
                        var cleave = new Cleave('.formatted-date', {
                            date: true,
                            delimiter: '-',
                            datePattern: ['d', 'm', 'Y']
                        });
                    </script>

                    <p>
                        <label>{l s='Telefoonnummer' mod='billinkpayment'}</label><br/>
                        <input type="text" name="phone" value="{$phone}" placeholder="{l s='Telefoonnummer'}" required/>
                    </p>
                    <p>
                        <input type="hidden" name="scbk" value="{$token}" required/>
                    </p>
                    <p>
                        <small>{l s='Na succesvolle controle kunt u direct afrekenen met Billink' mod='billinkpayment'}</small>
                    </p>
                    <p>
                        <strong>{l s='Klik op "Ik bevestig mijn order" om uw order te bevestigen.' mod='billinkpayment'}</strong>
                    </p>
                        <input type="hidden" name="isSubmitted" class="exclusive_large hideOnSubmit" />
                    </p>
                    {if $errors}
                        <div class="alert alert-danger">
                            <ul>
                                {foreach from=$errors item=item}
                                    <li>{$item}</li>
                                {/foreach}
                            </ul>
                        </div>
                    {/if}
                    </p>
                        <input type="submit" name="submit" value="{l s='Ik bevestig mijn order' mod='billinkpayment'}" class="exclusive_large hideOnSubmit" />
                    </p>
                </form>
                </div>
                </section>
            {/if}
        </div>
        <div class="span4"></div>
    </div>
</div>